#-------------------------------------------------------------------------------
#Utilisation du modèle de Cox
#-------------------------------------------------------------------------------

cox = coxph(Surv(AncEntree,AncSortie,non_censure,"counting")~AgeSurvenance,data=t)
test = cox.zph(cox)
wCox = survfit(cox,type="kaplan-meier")
sBase = as.vector(ancMin:ancMax)
qBase = as.vector(ancMin:(ancMax-1))

for(i in ancMin:ancMax)
	{
	sBase[i-ancMin+1] = min(wCox$surv[wCox$time/nbJoursMois<=i])
	}
sBase[1]=1 #min(wCox$surv[wCox$time/nbJoursMois<=(ancMin-1)])
qBase = (sBase[1:(ancMax-ancMin)] - sBase[2:(ancMax-ancMin+1)])/sBase[1:(ancMax-ancMin)]

x11()
plot(qBase,type="l",xlab="ancienneté",ylab="Taux de sortie")

tauxBaseCox=matrix(ncol=ncol(tauxAjustes),nrow=nrow(tauxAjustes))
for (age in ageMin:ageMax){
  tauxBaseCox[,(age-ageMin+1)]=1-(1-qBase)^(exp(cox$coefficients*age))
  }

#Pour les lissages il manque les expositions

# Lissage de la loi de r?f?rence par une loi de Weibull
x=c((ancMin+1):(ancMax-1))
f=function(a){sum((qBase[1:(ancMax-ancMin-1)]-(1-exp(-(x+1)^a+x^a)))^2)}
argmin=nlm(f,0.5)$estimate
qAjuste=1-exp(-(x+1)^argmin+x^argmin)

lnBase=log(1-qBase)
# Lissage de la loi de r?f?rence par un polyn?me
a=c(1:4)
x=c((ancMin+1):(ancMax-1))
f=function(a){sum((lnBase[1:(ancMax-ancMin-1)]-(a[1]+a[2]*x+a[3]*x^2+a[4]*x^3))^2)}
argmin=nlm(f,c(-.35,0,0,0),iterlim=10^7)$estimate
qAjuste=1-exp(argmin[1]+argmin[2]*x+argmin[3]*x^2+argmin[4]*x^3)